function example1_2_date
% Tests maximum of multiple Rayleigh quotients for all algorithms
%
    tab = zeros(120,10);
    minf = load('tex_example1_tab.txt', '%f');
    seed = [3 5 7 9 18 24 25 26 27 30];
    error = 0.0001;  % 
    n =[6 11 21]; 
    N =[20 100 200 500];    
    for i = 1:length(n)
        for j = 1:length(N)
            for k = 1 : lemgth(seed)          
                r = seed(k);
                rand('state', r);
                randn('state', r);  %
                epsi = 1e-1;
                for l = 1 : N(j)
                     Temp = randn(n(i), n(i));
                     A{l} = diag([1 : n(i)]) + epsi * (Temp' + Temp);
                end 
                x1U = randn(n, 1);
                x1.U = orth(x1U);
                for l = 1 : 5
                    method = l;   
                    [X, Y, F, timecost, tt, nftime, quadtime]  = test_MaxRQ(A, method, x1, r, minf(40 * (i-1) + 10 * (j-1) + k), n(i), N(j), error);
                    tab(40 * (i-1) + 10 * (j-1) + k, 2 * (l - 1) + 1) = tt;
                    tab(40 * (i-1) + 10 * (j-1) + k, 2 * l) = timecost;
                    disp(r);
                end
            end
        end
    end

    fout = fopen('tex_example1_2_tab.txt','w');
    for i=1 : 120
        for j = 1 : 10
            fprintf(fout,'%f ',tab(i,j));
        end
        fprintf(fout,'\n');
    end
    fclose(fout);
end

function [X, Y, F, timecost, tt, nftime, quadtime] = test_MaxRQ(A, method, x1, r, minf,n, N, error)
% Test of maximum of multiple Rayleigh quotients

    params.x0 = x1;
    params.max_t = 5000;
    params.error = error;
    params.minf = minf;
    if(method == 1)
        Retraction = 4;
        VT = 19;
        H = eye(n - 1);       
        params.H0 = H;
        params.err = 1e-5;       
        params.manifold = 2;
        params.rho = 0.1;
        params.mu0 = 0.18;
        params.minstepsize = eps;
        params.maxstepsize = 1;
        params.thetaA = 0.1;
        params.thetaL = 0.1;
        params.thetaR = 0.45; 
        params.thetaT = 0.2;
        params.D = 100;
        params.E = 1; 
        params.gamma = 0.15;
        params.kappa = 0.25;
        params.Gamma = 50;
        params.omega = 2;
        params.update = 1;
        params.t = n - 1;
    elseif(method == 4)
        Retraction = 1;
        VT = 1;
        params.delta = 1e-5;
        params.epsilon = 0.1;
        params.gamma = 0.5;
        params.sigma = 1;
        params.theta_epsilon = 0.1;
        params.theta_delta = 1;
        params.c = 0.005;
        params.max_ls = 5000;
        params.manifold = 1;
    elseif(method == 5)
        Retraction = 4;
        VT = 19;
        H = eye(n - 1);       
        params.H0 = H;
        params.err = 1e-5;       
        params.manifold = 2;
        params.rho = 0.1;
        params.mu0 = 0.18;
        params.minstepsize = eps;
        params.maxstepsize = 1;
        params.thetaA = 0.1;
        params.thetaL = 0.1;
        params.thetaR = 0.45; 
        params.thetaT = 0.2;
        params.D = 100;
        params.E = 1; 
        params.gamma = 0.15;
        params.kappa = 0.25;
        params.Gamma = 50;
        params.omega = 2;
        params.update = 1;
        params.t = 500;
    
    else
        if(method == 2)
            Retraction = 2;
        else
            Retraction = 4;
        end
        VT =1;
        params.x0 = x1;
        params.tol = 1e-5;
        params.epsilon = 0.05;
        params.alpha = 1.2;
        params.m_L = 0.0002;
        params.mu_l = 26;
        params.max_L = 50;
        params.manifold = 2;
    end
    
   
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};         
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, Y, F, timecost, tt, nftime, quadtime] = driver_MaxRQ(A, method, fns, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    fprintf('average time cost of %d times is %f. \n', times, total_timecost);  
end
% 
