function example3_date
% obtain the minimum of the geometric median problem
    tab = zeros(100, 1);
    minf = zeros(100, 1);
    n =[3 5 10 20 50 100 200 500 1000 2000]; 
    m =5000;
    for i=1 : length(n)
        for j = 1 : 10
            r = j;
            [X, Y, F, timecost, tt, nftime, quadtime] = test_RGM1(r, n(i), m, minf(10 * (i-1) + j));
            tab(10 * (i - 1) + j, 1) = F(end).f;
            disp(r);
        end
    end
    fout = fopen('tex_example3_tab.txt','w');
    for i = 1 : 100
        fprintf(fout,'%f\n',tab(i, 1));
    end
    fclose(fout);
end

function [X, Y, F, timecost, tt, nftime, quadtime] = test_RGM1(r, n, m, minf)
% test of the geometric median problem
%
    fprintf('test for the geometric median problem. \n');
    rand('state', r);
    randn('state', r); 
    method = 1;
    Retraction = 4;
    VT = 19;  
    for i = 1 : m
        x.U = orth(rand(n, 1));
        Q{i} = x;
    end   

    x1U = rand(n, 1);
    x1.U = orth(x1U);
    H0 = eye(n - 1);

    params.x0 = x1;
    params.H0 = H0;
    params.err = 1e-5;
    params.error = 0;
    params.max_t = 5000;
    params.manifold = 2;
    params.rho = 0.1;
    params.mu0 = 0.18;
    params.minstepsize = eps;
    params.maxstepsize = 1;
    params.minf = minf;
    params.thetaA = 0.1;
    params.thetaL = 0.1;
    params.thetaR = 0.45;
    params.thetaT = 0.2;
    params.D = 100;
    params.E = 1; 
    params.gamma = 0.15;
    params.kappa = 0.25;
    params.Gamma = 50;
    params.omega = 2;
    params.update = 1;
    params.t = n - 1;
    
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};         
    
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, Y, F, timecost, tt, nftime, quadtime] = driver_RGM(Q, fns, method, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end
