function example4_2_date
% Tests the the bounding box problem for all algorithms
%
    tab=zeros(60, 10);
    minf = load('tex_example4_tab.txt', '%f');
%     minf = zeros(60, 1);
    seed = 1 : 2 : 20;
    error = 0.0001;
    d =[3 4 5 6 8 10]; 
    n =1000;

    for i = 1 : length(d)
        for j = 1 : length(seed)
            r = seed(j);

            for k = 1 : 5
                method = k;   
%                 try
                    [X, Y, F, timecost, tt]  = test_OBB(method, r, minf(10 * (i-1) + j), n, d(i), error);
                    tab(10 * (i-1) + j, 2 * (k - 1) + 1) = tt;
                    tab(10 * (i-1) + j, 2 * k) = timecost;
%                 catch
%                     tab(10 * (i-1) + j, 2 * (k-1)+1) = 500;
%                     tab(10 * (i-1) + j, 2 * k) = 10000;
%                     continue;
%                 end
                disp(r);
            end       
        end
    end

    fout = fopen('tex_example4_2_tab.txt','w');
    for i=1 : 60
        for j = 1 : 10
            fprintf(fout,'%f ',tab(i,j));
        end
        fprintf(fout,' \n');
    end
    fclose(fout);
end

function [X, Y, F, timecost, tt, nftime, quadtime] = test_OBB(method, r, minf, n, d, error)
% Test the the bounding box problem
%
    rand('state', r);
    randn('state', r);
    x1.U = orth(randn(d, d)); 
    A = 0.75 * rand(d, n);
    H0 = eye(d * (d - 1) * 0.5); 
    N = d * (d - 1) * 0.5;
    params.x0 = x1;
    params.H0 = H0;
    
    params.manifold = 3;
    params.error = 1e-4;
    params.minf = minf;
    params.err = 1e-5;
    params.tol = 1e-8;
    params.rho = 0.1;
    params.mu0 =0.18;
    params.minstepsize = eps;
    params.maxstepsize = 1;
    params.thetaA = 0.1;
    params.thetaL = 0.1;
    params.thetaR = 0.45;
    params.thetaT = 0.2;
    params.m = 8;
    params.D = 100;
    params.E = 1; 

    params.kappa = 0.25;   
    params.omega = 2;
    params.update =1;
    params.alpha = 1.2;
    params.m_L = 0.0002;
    params.mu_l = 26;
    params.max_L = 50;
    
    params.theta_epsilon = 0.1;
    params.theta_delta = 1; 
    params.c = 0.005;
    params.max_ls = 5000;
    params.delta = 1e-5;
       
    if (method == 1)
        Retraction = 2;
        VT = 13;
        params.t = 2^d * N; 
        params.Gamma = 50;
        params.gamma = 0.15;       
        params.max_t = inf; 
    elseif (method == 2)
        Retraction = 2;
        VT = 7;
        params.epsilon = 0.05;
        params.max = inf;
        params.max_t = 5000;
    elseif (method == 3)  
        Retraction = 2;
        VT = 7;
        params.epsilon = 0.05; 
        params.max = inf;
        params.max_t = 5000;
    elseif (method == 4)
        Retraction = 1;
        VT = 2;
        params.epsilon = 0.1;
        params.gamma = 0.5;
        params.max_t = 5000;
        params.manifold = 3;      
    else  
        Retraction = 2;
        VT = 13;
        params.t = 500; 
        params.Gamma = 1000;
        params.gamma = 0.15;   
        params.max_t = inf; 
    end
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};
    
   
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};         
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, Y, F, timecost, tt] = driver_OBB(A, method, fns, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    fprintf('average time cost of %d times is %f. \n', times, total_timecost);  
end

