function example4_date
% obtain the minimum of the bounding box problem
    tab = zeros(60,1);
    minf = zeros(60,1);
    d =[3 4 5 6 8 10]; 
    seed = 1 : 2 : 20;
    n = 1000;
    for i = 1 : length(d)
        for j = 1 : length(seed)
            r = seed(j);
            [X, Y, F, timecost, tt] = test_OBB1(r, minf(10 * (i-1) + j), n, d(i));
            tab(10 * (i - 1) + j, 1) = F(end).f;
            disp(r);
        end
    end
    fout = fopen('tex_example4_tab.txt','w');
    for i=1 : 60
        fprintf(fout,'%f\n',tab(i,1));
    end
    fclose(fout);
end

function [X, Y, F, timecost, tt]= test_OBB1(r, minf, n, d)
   fprintf('test for Rayleigh Quotient minimization. \n');
%    fprintf('x^* = arg min_{x in S^{n - 1}} x^T A x, where A is a n by n symmetric matrix. \n');
%     r = rand();   %(0,1)随机数 均匀分布
%     r = floor(r * 10000);  %floor(x) 不大于x的最大整数
%     r=1;
    rand('state', r);
    randn('state', r);  
    method = 1;
    Retraction = 2;
    VT = 13;
    
    x1.U = orth(randn(d, d));  
    A = 0.75 * rand(d, n);
    H0 = eye(d * (d - 1) * 0.5);
    N = d * (d - 1) * 0.5;

    params.x0 = x1;
    params.H0 = H0;
    params.err = 1e-4;
    params.error = 0;
    params.max_t = 5000;
    params.manifold = 3;
    params.rho = 0.1;
    params.mu0 =0.18;
    params.minstepsize = eps;
    params.maxstepsize = 1;
    params.minf = minf;
    params.thetaA = 0.1;
    params.thetaL = 0.1;
    params.thetaR = 0.45;
    params.thetaT = 0.2;
    params.D = 100;
    params.E = 1; 
    params.gamma = 0.15;
    params.kappa = 0.25;
    params.Gamma = 50;
    params.omega = 2;
    params.update =1;
    params.t = 2^d * N;
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};

    
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, Y, F, timecost,tt,nftime,quadtime] = driver_OBB(A, method, fns, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end

    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end

