function perf(T,logplot)
%PERF    Performace profiles
%
% PERF(T,logplot)-- produces a performace profile as described in
%   Benchmarking optimization software with performance profiles,
%   E.D. Dolan and J.J. More', 
%   Mathematical Programming, 91 (2002), 201--213.
% Each column of the matrix T defines the performance data for a solver.
%%% Failures on a given problem are represented by a NaN.   ܹؼ
% The optional argument logplot is used to produce a 
% log (base 2) performance plot.
%
% This function is based on the perl script of Liz Dolan.
%
% Jorge J. More', June 2004
% clear all
% clc
% T=rand(50,4)
% nargin=2
% logplot=1;
if (nargin < 2) logplot = 0; end

%plot LineSpec
%colors  = ['m' 'b' 'r' 'g' 'k' 'c' 'y'];% 'm'Ʒɫ 'w'Ϊɫû
colors  = [[0.5 0.5 0.5 0.5 0.5] 'b' 'm' 'g' 'k' 'k' 'y' 'm' 'b' 'r' 'g' 'k' 'c' 'y'];% ޸ĵģһɫ7*2=14
%lines   = [':' '-' {'-.'} {'--'}];%޸ģ4
%lines   = [':' '-' {'-.'} {'--'} ':'];     ԭģֻ5ߣ4+1=5
% lines   = ['-' '-' {'-'} {'-'} '-' '-' {'-'} {'-'} ':' '-' {'-.'} {'--'}];
lines   = ['-x' '-*' {'-d'} {'-v'} '-o' '-' {'-.'} {'--'} ':' '-' {'-.'} {'--'}];      %޸ĵģ12ߣ4*3=12
%markers = ['x' '*' 's' 'd' 'v' '^' 'o'];% οhttp://wiki.ilovematlab.cn/doc-view-54.html
%markers = ['*' 'd' 's' 'd' 'v' '^' 'o' '+' 'h' 'p' '>' '<' '.'];        %޸ĵģ6marker13

[np,ns] = size(T);

% Minimal performance per solver

minperf = min(T,[],2);%ÿеСһ

% Compute ratios and divide by smallest element in each row.

r = zeros(np,ns);
for p = 1: np
  r(p,:) = T(p,:)/minperf(p);
end
if (logplot) r = log(r); end
% if (logplot) r = log(r)/log(100); end

max_ratio = max(max(r));%ȡrԪеֵ

% Replace all NaN's with twice the max_ratio and sort.

r(find(isnan(r))) = 2*max_ratio;%r еNaNֵΪrֵ2
r = sort(r);

% Plot stair graphs with markers.

%clf;
set(0,'defaultaxesfontsize',10, ...
'defaultaxeslinewidth',0.7, ...
'defaultlinelinewidth',0.8,'defaultpatchlinewidth',0.8);
set(0,'defaultlinemarkersize',3.5);
for s = 1: ns
 [xs,ys] = stairs(r(:,s),[1:np]/np);
 option = [lines(s) colors(s)];
 plot(xs,ys,cell2mat(option),'MarkerSize',3.5,'LineWidth',0.8);
 hold on;
end

% Axis properties are set so that failures are not shown,
% but with the max_ratio data points shown. This highlights
% the "flatline" effect.
%set(gca,'xlim',[0,3])  x ķΧ

axis([ 1 1.1*max_ratio 0 1 ]);%1ʼʾ,ȡָʽ
% axis([ 0 1.1*max_ratio 0 1 ]);%0ʼʾ,ȡʽú1ʼ
% Legends and title should be added.



