function d= test_MaxRQ(r,minf)
    fprintf('test for Maximum of multiple Rayleigh quotients. \n');
    fprintf('x^* = arg min_{x in S^{n - 1}} max_{i=1,2 ...m} 1/2 x^T A_i x, where A_i is a n by n symmetric matrix. \n');
    r = rand();
    r = floor(r * 10000);
    minf=0;
    r = 1;
    fprintf('In this case, n = 20, p = 1. A_i and x1 are chosen randomly. Random seed is %d \n', r);
    fprintf('which algorithm do you want to test: \n');
    fprintf('1, RQNBM \n');
    fprintf('2, RPBM \n');
    fprintf('3, RPBM \n');
    fprintf('4, REsubGA \n');
    fprintf('5, M-RQNBM \n');    
    fprintf('otherwise, break \n');
    method = input('please input: ');
    if(method < 1 || method > 5)
        fprintf('exit! \n');
        return;
    end
    % fprintf('which retraction do you want to test: \n');
    % fprintf('1, exp (quotient) \n');
    % fprintf('2, exp (embedded) \n');
    % fprintf('3, qf (quotient)\n');
    % fprintf('4, qf (embedded)\n');
    % fprintf('5, construct (quotient)\n');
    % fprintf('6, construct (embedded)\n');
    % fprintf('otherwise, break \n');
    % Retraction = input('please input: ');
    Retraction = 4;
    % if(Retraction < 1 || Retraction > 6)
    %     fprintf('exit! \n');
    %     return;
    % end
    
    % fprintf('which vector transport do you want to test: \n');
    % fprintf('1, Emb&Quo nonIso: vector transport by projection \n')
    % fprintf('2, Emb Iso: parallel transport \n')
    % fprintf('3, Emb Iso: direct-rotation with basis on tangent space \n')
    % fprintf('4, Emb Iso: direct-rotation with basis on normal space \n')
    % fprintf('5, Emb Iso: smooth basis on tangent space \n')
    % fprintf('6, Emb Iso: smooth basis on normal space \n')
    % fprintf('7, Emb Iso: intrinsic approach \n')
    % fprintf('8, Quo Iso: parallel transport \n')
    % fprintf('9, Quo Iso: direct-rotation with basis on horizontal space \n')
    % fprintf('10,Quo Iso: direct-rotation with basis on vertical space \n')
    % fprintf('11,Quo Iso: smooth basis on horizontal space \n')
    % fprintf('12,Quo Iso: smooth basis on vertical space \n')
    % fprintf('13,Quo Iso: intrinsic approach \n')
    % fprintf('14,Emb Locking-Iso(qf): direct-rotation with basis on tangent space \n')
    % fprintf('15,Emb Locking-Iso(qf): direct-rotation with basis on normal space \n')
    % fprintf('16,Emb Locking-Iso(qf): smooth basis on tangent space \n')
    % fprintf('17,Emb Locking-Iso(qf): smooth basis on normal space \n')
    % fprintf('18,Emb Locking-Iso(qf): construct vector transport \n')
    % fprintf('19,Emb Locking-Iso(qf): intrinsic approach \n')
    % fprintf('20,Quo Locking-Iso(qf): direct-rotation with basis on horizontal space \n')
    % fprintf('21,Quo Locking-Iso(qf): direct-rotation with basis on vertical space \n')
    % fprintf('22,Quo Locking-Iso(qf): smooth basis on horizontal space \n')
    % fprintf('23,Quo Locking-Iso(qf): smooth basis on vertical space \n')
    % fprintf('24,Quo Locking-Iso(qf): construct vector transport \n')
    % fprintf('25,Quo Locking-Iso(qf): intrinsic approach \n')
    % fprintf('26,Emb Locking-nonIso(qf): vector transport by projection \n')
    % fprintf('otherwise, break \n');
    % VT = input('please input: ');
    VT = 19;
    % if(VT < 1 || VT > 26)
    %     fprintf('exit! \n');
    %     return;
    % end
         
    rand('state', r);
    randn('state', r);  %
    n = 21; 
    p = 1;
    N = 500; 
    epsi = 1e-1;
    for i = 1 : N
         Temp = randn(n, n);
         A{i} = diag([1:n]) + epsi * (Temp' + Temp);
    end
%    epsi = 0.1;
%     for i = 1 : N
%          Temp = sprand(n, n, 0.002);
% %          A(:, :, i) = diag([n:-1:1]) + epsi * (Temp' + Temp);
%          B(:, :, i) = diag([1:n]) + epsi * (Temp' + Temp);
%          % C(:, :, i) = C(:, :, i) / norm(C(:, :, i));
%          A{i} = sparse(B(:, :, i));
%     end
%      A = sparse(A);
    x1U = randn(n, 1);
    x1.U = orth(x1U);
    H0 = eye(n-1);

    params.x0 = x1;
    params.H0 = H0;
    
    params.manifold = 2;
    params.error = 1e-4;
    params.minf = minf;
    params.err = 1e-5;
    params.tol = 1e-8;
    params.rho = 0.1;
    params.mu0 =0.18;
    params.minstepsize = eps;
    params.maxstepsize = 1;
    params.thetaA = 0.1;
    params.thetaL = 0.1;
    params.thetaR = 0.45;
    params.thetaT = 0.2;
    params.m = 8;
    params.D = 100;
    params.E = 1; 

    params.kappa = 0.25;   
    params.omega = 2;
    params.update =1;
    params.alpha = 1.2;
    params.m_L = 0.0002;
    params.mu_l = 26;
    params.max_L = 50;
    
    params.theta_epsilon = 0.1;
    params.theta_delta = 1; 
    params.c = 0.005;
    params.max_ls = 5000;
    params.delta = 1e-5;
       
    if (method == 1)
        params.t = n - 1; 
        params.Gamma = 50;
        params.gamma = 0.15;       
        params.max_t = inf; 
    elseif (method == 2)
        params.epsilon = 0.05;
        params.max = inf;
        params.max_t = 5000;
    elseif (method == 3)       
        params.epsilon = 0.05;
        params.max = inf;
        params.max_t = 5000;
    elseif (method == 4)
        x1.U = x1U / norm(x1U);
        params.x0 = x1;
        params.manifold = 1;
        Retraction = 1;
        VT = 1;
        params.epsilon = 0.1;
        params.gamma = 0.5;
        params.max_t = 5000;
        params.manifold = 1;      
    else        
        params.t = 500; 
        params.Gamma = 1000;
        params.gamma = 0.15;   
        params.max_t = inf; 
    end
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};

    
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, Y, F, timecost, tt, nftime, quadtime] = driver_MaxRQ(A, method, fns, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    d=[F(end).f length(F) total_timecost tt nftime quadtime];
    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end
